﻿// cc-by 3.0 Austria, (c) 2011 Markus Loeberbauer
// http://ssw.jku.at/Teaching/Lectures/SpezialLVA/JavaFX/
import javafx.animation.Interpolator;
import javafx.animation.KeyFrame;
import javafx.animation.KeyValue;
import javafx.animation.Timeline;
import javafx.animation.TimelineBuilder;
import javafx.application.Application;
import javafx.beans.binding.Bindings;
import javafx.beans.property.DoubleProperty;
import javafx.beans.property.SimpleDoubleProperty;
import javafx.scene.Group;
import javafx.scene.Scene;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;
import javafx.util.Duration;

public class TimePulse extends Application {
  public static void main(String[] args) {
    Application.launch(args);
  }
  
  @Override
  public void start(Stage primaryStage) {
    primaryStage.setTitle("Pulse");
    primaryStage.setWidth(400);
    primaryStage.setHeight(400);
    
    Circle circle;
    DoubleProperty radiusMultiplicator = new SimpleDoubleProperty();
    
    Scene scene = new Scene(new Group(circle = new Circle()));
    
    circle.centerXProperty().bind(scene.widthProperty().divide(2));
    circle.centerYProperty().bind(scene.heightProperty().divide(2));
   
    circle.radiusProperty().bind(
        radiusMultiplicator.multiply(
          Bindings.min(scene.widthProperty(), scene.heightProperty())
          .divide(2)));
    
    Timeline pulse = TimelineBuilder.create()
        .autoReverse(true)
        .cycleCount(Timeline.INDEFINITE)
        .keyFrames(
          new KeyFrame(Duration.ZERO, new KeyValue(radiusMultiplicator, 0)),
          new KeyFrame(Duration.seconds(5), new KeyValue(radiusMultiplicator, 1, Interpolator.EASE_BOTH))
        ).build();
    
    pulse.play();
    
    primaryStage.setScene(scene);
    primaryStage.show();
  }
}
